// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

// tslint:disable
/**
 * eGesetzgebung Platform
 * This is the rest interface offered by the eGesetzgebung Platform backend.  Please provide __JW Access Token__ using button \'Authorize\' to access protected endpoints. Use the following instructions to get token:  1. on CMD/Bash/Terminal: ```curl -d \"client_id=user-management\" -d \"client_secret=INSERT_IAM_SECRET\" -d \"grant_type=password&username=INSERT_USER_EMAIL&password=INSERT_USER_PASSWORD\" \"INSERT_IAM_URL/realms/bund/protocol/openid-connect/token\"``` 2. copy access_token (without quotes, you can use jq or other tools to extract this value automatically) 3. insert value into \'JWToken\' field under \'Authorize\' and press \'Authorize\' 4. now you should have access to user protected endpoint  __FYI:__ token expires after 60 seconds. On non-production systems only a warning is displayed so you can work smoothly, but on production systems you have to frequently provide a new token.
 *
 * The version of the OpenAPI document: 9.0.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import type { Observable } from 'rxjs';
import type { AjaxResponse } from 'rxjs/ajax';
import { BaseAPI, throwIfNullOrUndefined, encodeURI } from '../runtime';
import type { OperationOpts, HttpHeaders } from '../runtime';
import type {
    RegelungsvorhabenTypType,
    ZeitplanungsvorlageCreateRequestDTO,
    ZeitplanungsvorlageEntityDTO,
    ZeitplanungsvorlageEntityListResponseShortDTO,
    ZeitplanungsvorlageEntityResponseDTO,
    ZeitplanungsvorlagePhaseRequest,
    ZeitplanungsvorlageTerminRequest,
    ZeitvorlagevorlagenBauplanDTO,
} from '../models';

export interface AddDateToZeitplanungsvorlageLightRequest {
    zeitplanungsvorlageTerminRequest: ZeitplanungsvorlageTerminRequest;
}

export interface AddPhaseToZeitplanungsvorlageLightRequest {
    zeitplanungsvorlagePhaseRequest: ZeitplanungsvorlagePhaseRequest;
}

export interface CreateZeitplanungsvorlageLightRequest {
    zeitplanungsvorlageCreateRequestDTO: ZeitplanungsvorlageCreateRequestDTO;
}

export interface DeleteZeitplanungsvorlagenelementFromZeitplanungsvorlageLightRequest {
    elementId: string;
    zeitplanungsvorlageEntityDTO: ZeitplanungsvorlageEntityDTO;
}

export interface GetBauplaeneForVorhabenartLightRequest {
    vorhabenart: RegelungsvorhabenTypType;
}

export interface ModifyDateInZeitplanungsvorlageLightRequest {
    elementId: string;
    zeitplanungsvorlageTerminRequest: ZeitplanungsvorlageTerminRequest;
}

export interface ModifyPhaseInZeitplanungsvorlageLightRequest {
    elementId: string;
    zeitplanungsvorlagePhaseRequest: ZeitplanungsvorlagePhaseRequest;
}

/**
 * no description
 */
export class ZeitplanungsvorlageLightControllerApi extends BaseAPI {

    /**
     * Fügt einer Zeitplanungsvorlage einen neuen Termin hinzu
     * POST ZEITPLANUNGSVORLAGE DATE
     */
    addDateToZeitplanungsvorlageLight({ zeitplanungsvorlageTerminRequest }: AddDateToZeitplanungsvorlageLightRequest): Observable<ZeitplanungsvorlageEntityResponseDTO>
    addDateToZeitplanungsvorlageLight({ zeitplanungsvorlageTerminRequest }: AddDateToZeitplanungsvorlageLightRequest, opts?: OperationOpts): Observable<AjaxResponse<ZeitplanungsvorlageEntityResponseDTO>>
    addDateToZeitplanungsvorlageLight({ zeitplanungsvorlageTerminRequest }: AddDateToZeitplanungsvorlageLightRequest, opts?: OperationOpts): Observable<ZeitplanungsvorlageEntityResponseDTO | AjaxResponse<ZeitplanungsvorlageEntityResponseDTO>> {
        throwIfNullOrUndefined(zeitplanungsvorlageTerminRequest, 'zeitplanungsvorlageTerminRequest', 'addDateToZeitplanungsvorlageLight');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<ZeitplanungsvorlageEntityResponseDTO>({
            url: '/zeitplanungsvorlage-light/date',
            method: 'POST',
            headers,
            body: zeitplanungsvorlageTerminRequest,
        }, opts?.responseOpts);
    };

    /**
     * Fügt einer Zeitplanungsvorlage eine neue Phase hinzu
     * POST ZEITPLANUNGSVORLAGE PHASE
     */
    addPhaseToZeitplanungsvorlageLight({ zeitplanungsvorlagePhaseRequest }: AddPhaseToZeitplanungsvorlageLightRequest): Observable<ZeitplanungsvorlageEntityResponseDTO>
    addPhaseToZeitplanungsvorlageLight({ zeitplanungsvorlagePhaseRequest }: AddPhaseToZeitplanungsvorlageLightRequest, opts?: OperationOpts): Observable<AjaxResponse<ZeitplanungsvorlageEntityResponseDTO>>
    addPhaseToZeitplanungsvorlageLight({ zeitplanungsvorlagePhaseRequest }: AddPhaseToZeitplanungsvorlageLightRequest, opts?: OperationOpts): Observable<ZeitplanungsvorlageEntityResponseDTO | AjaxResponse<ZeitplanungsvorlageEntityResponseDTO>> {
        throwIfNullOrUndefined(zeitplanungsvorlagePhaseRequest, 'zeitplanungsvorlagePhaseRequest', 'addPhaseToZeitplanungsvorlageLight');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<ZeitplanungsvorlageEntityResponseDTO>({
            url: '/zeitplanungsvorlage-light/phase',
            method: 'POST',
            headers,
            body: zeitplanungsvorlagePhaseRequest,
        }, opts?.responseOpts);
    };

    /**
     * Legt eine neue Zeitplanungsvorlage an
     * POST ZEITPLANUNGSVORLAGE
     */
    createZeitplanungsvorlageLight({ zeitplanungsvorlageCreateRequestDTO }: CreateZeitplanungsvorlageLightRequest): Observable<ZeitplanungsvorlageEntityResponseDTO>
    createZeitplanungsvorlageLight({ zeitplanungsvorlageCreateRequestDTO }: CreateZeitplanungsvorlageLightRequest, opts?: OperationOpts): Observable<AjaxResponse<ZeitplanungsvorlageEntityResponseDTO>>
    createZeitplanungsvorlageLight({ zeitplanungsvorlageCreateRequestDTO }: CreateZeitplanungsvorlageLightRequest, opts?: OperationOpts): Observable<ZeitplanungsvorlageEntityResponseDTO | AjaxResponse<ZeitplanungsvorlageEntityResponseDTO>> {
        throwIfNullOrUndefined(zeitplanungsvorlageCreateRequestDTO, 'zeitplanungsvorlageCreateRequestDTO', 'createZeitplanungsvorlageLight');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<ZeitplanungsvorlageEntityResponseDTO>({
            url: '/zeitplanungsvorlage-light',
            method: 'POST',
            headers,
            body: zeitplanungsvorlageCreateRequestDTO,
        }, opts?.responseOpts);
    };

    /**
     * Löscht eine Phase oder einen Termin aus der Zeitplanungsvorlage
     * DELETE ZEITPLANUNGSVORLAGE PHASE/DATE
     */
    deleteZeitplanungsvorlagenelementFromZeitplanungsvorlageLight({ elementId, zeitplanungsvorlageEntityDTO }: DeleteZeitplanungsvorlagenelementFromZeitplanungsvorlageLightRequest): Observable<ZeitplanungsvorlageEntityResponseDTO>
    deleteZeitplanungsvorlagenelementFromZeitplanungsvorlageLight({ elementId, zeitplanungsvorlageEntityDTO }: DeleteZeitplanungsvorlagenelementFromZeitplanungsvorlageLightRequest, opts?: OperationOpts): Observable<AjaxResponse<ZeitplanungsvorlageEntityResponseDTO>>
    deleteZeitplanungsvorlagenelementFromZeitplanungsvorlageLight({ elementId, zeitplanungsvorlageEntityDTO }: DeleteZeitplanungsvorlagenelementFromZeitplanungsvorlageLightRequest, opts?: OperationOpts): Observable<ZeitplanungsvorlageEntityResponseDTO | AjaxResponse<ZeitplanungsvorlageEntityResponseDTO>> {
        throwIfNullOrUndefined(elementId, 'elementId', 'deleteZeitplanungsvorlagenelementFromZeitplanungsvorlageLight');
        throwIfNullOrUndefined(zeitplanungsvorlageEntityDTO, 'zeitplanungsvorlageEntityDTO', 'deleteZeitplanungsvorlagenelementFromZeitplanungsvorlageLight');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<ZeitplanungsvorlageEntityResponseDTO>({
            url: '/zeitplanungsvorlage-light/element/{elementId}'.replace('{elementId}', encodeURI(elementId)),
            method: 'DELETE',
            headers,
            body: zeitplanungsvorlageEntityDTO,
        }, opts?.responseOpts);
    };

    /**
     * Lädt eine Liste von Systemvorlagen für Phasen/Terminen zu einer Vorhabenart
     * GET ZEITPLANUNGSVORLAGE PHASES/DATES TEMPLATES
     */
    getBauplaeneForVorhabenartLight({ vorhabenart }: GetBauplaeneForVorhabenartLightRequest): Observable<Array<ZeitvorlagevorlagenBauplanDTO>>
    getBauplaeneForVorhabenartLight({ vorhabenart }: GetBauplaeneForVorhabenartLightRequest, opts?: OperationOpts): Observable<AjaxResponse<Array<ZeitvorlagevorlagenBauplanDTO>>>
    getBauplaeneForVorhabenartLight({ vorhabenart }: GetBauplaeneForVorhabenartLightRequest, opts?: OperationOpts): Observable<Array<ZeitvorlagevorlagenBauplanDTO> | AjaxResponse<Array<ZeitvorlagevorlagenBauplanDTO>>> {
        throwIfNullOrUndefined(vorhabenart, 'vorhabenart', 'getBauplaeneForVorhabenartLight');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Array<ZeitvorlagevorlagenBauplanDTO>>({
            url: '/zeitplanungsvorlage-light/bauplaene/{vorhabenart}'.replace('{vorhabenart}', encodeURI(vorhabenart)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Lädt eine Zeitplanungsvorlage (nur Systemvorschläge!)
     * GET ZEITPLANUNGSVORLAGE
     */
    getZeitplanungsvorlagenAlleLight(): Observable<Array<ZeitplanungsvorlageEntityResponseDTO>>
    getZeitplanungsvorlagenAlleLight(opts?: OperationOpts): Observable<AjaxResponse<Array<ZeitplanungsvorlageEntityResponseDTO>>>
    getZeitplanungsvorlagenAlleLight(opts?: OperationOpts): Observable<Array<ZeitplanungsvorlageEntityResponseDTO> | AjaxResponse<Array<ZeitplanungsvorlageEntityResponseDTO>>> {
        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Array<ZeitplanungsvorlageEntityResponseDTO>>({
            url: '/zeitplanungsvorlage-light/alle',
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der Zeitplanungsvorlagen ab (»Zeitplanungsvorlagen«) (nur Systemvorschläge!)
     * GET ZEITPLANUNGSVORLAGEN LIST FOR USER
     */
    getZeitplanungsvorlagenLight(): Observable<ZeitplanungsvorlageEntityListResponseShortDTO>
    getZeitplanungsvorlagenLight(opts?: OperationOpts): Observable<AjaxResponse<ZeitplanungsvorlageEntityListResponseShortDTO>>
    getZeitplanungsvorlagenLight(opts?: OperationOpts): Observable<ZeitplanungsvorlageEntityListResponseShortDTO | AjaxResponse<ZeitplanungsvorlageEntityListResponseShortDTO>> {
        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<ZeitplanungsvorlageEntityListResponseShortDTO>({
            url: '/zeitplanungsvorlage-light/zeitplanungsvorlagen',
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ändert einen Termin
     * PUT ZEITPLANUNGSVORLAGE DATE
     */
    modifyDateInZeitplanungsvorlageLight({ elementId, zeitplanungsvorlageTerminRequest }: ModifyDateInZeitplanungsvorlageLightRequest): Observable<ZeitplanungsvorlageEntityResponseDTO>
    modifyDateInZeitplanungsvorlageLight({ elementId, zeitplanungsvorlageTerminRequest }: ModifyDateInZeitplanungsvorlageLightRequest, opts?: OperationOpts): Observable<AjaxResponse<ZeitplanungsvorlageEntityResponseDTO>>
    modifyDateInZeitplanungsvorlageLight({ elementId, zeitplanungsvorlageTerminRequest }: ModifyDateInZeitplanungsvorlageLightRequest, opts?: OperationOpts): Observable<ZeitplanungsvorlageEntityResponseDTO | AjaxResponse<ZeitplanungsvorlageEntityResponseDTO>> {
        throwIfNullOrUndefined(elementId, 'elementId', 'modifyDateInZeitplanungsvorlageLight');
        throwIfNullOrUndefined(zeitplanungsvorlageTerminRequest, 'zeitplanungsvorlageTerminRequest', 'modifyDateInZeitplanungsvorlageLight');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<ZeitplanungsvorlageEntityResponseDTO>({
            url: '/zeitplanungsvorlage-light/date/{elementId}'.replace('{elementId}', encodeURI(elementId)),
            method: 'PUT',
            headers,
            body: zeitplanungsvorlageTerminRequest,
        }, opts?.responseOpts);
    };

    /**
     * Ändert eine Phase
     * PUT ZEITPLANUNGSVORLAGE PHASE
     */
    modifyPhaseInZeitplanungsvorlageLight({ elementId, zeitplanungsvorlagePhaseRequest }: ModifyPhaseInZeitplanungsvorlageLightRequest): Observable<ZeitplanungsvorlageEntityResponseDTO>
    modifyPhaseInZeitplanungsvorlageLight({ elementId, zeitplanungsvorlagePhaseRequest }: ModifyPhaseInZeitplanungsvorlageLightRequest, opts?: OperationOpts): Observable<AjaxResponse<ZeitplanungsvorlageEntityResponseDTO>>
    modifyPhaseInZeitplanungsvorlageLight({ elementId, zeitplanungsvorlagePhaseRequest }: ModifyPhaseInZeitplanungsvorlageLightRequest, opts?: OperationOpts): Observable<ZeitplanungsvorlageEntityResponseDTO | AjaxResponse<ZeitplanungsvorlageEntityResponseDTO>> {
        throwIfNullOrUndefined(elementId, 'elementId', 'modifyPhaseInZeitplanungsvorlageLight');
        throwIfNullOrUndefined(zeitplanungsvorlagePhaseRequest, 'zeitplanungsvorlagePhaseRequest', 'modifyPhaseInZeitplanungsvorlageLight');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<ZeitplanungsvorlageEntityResponseDTO>({
            url: '/zeitplanungsvorlage-light/phase/{elementId}'.replace('{elementId}', encodeURI(elementId)),
            method: 'PUT',
            headers,
            body: zeitplanungsvorlagePhaseRequest,
        }, opts?.responseOpts);
    };

}
